package com.lbs.ws.test;

import java.rmi.RemoteException;

import org.apache.axis2.client.ServiceClient;
import org.apache.axis2.context.ConfigurationContext;
import org.apache.axis2.context.ConfigurationContextFactory;
import org.apache.rampart.handler.WSSHandlerConstants;
import org.apache.rampart.handler.config.OutflowConfiguration;

import com.lbs.util.JLbsFileUtil;
import com.lbs.ws.Create;
import com.lbs.ws.CreateResponse;
import com.lbs.ws.DataExchangeServiceStub;
import com.lbs.ws.Describe;
import com.lbs.ws.DescribeResponse;
import com.lbs.ws.GetByKey;
import com.lbs.ws.GetByKeyResponse;
import com.lbs.ws.RemoveByKey;
import com.lbs.ws.RemoveByKeyResponse;
import com.lbs.ws.Save;
import com.lbs.ws.SaveResponse;
import com.lbs.ws.xsd.DescribeParameters;
import com.lbs.ws.xsd.DescribeResult;
import com.lbs.ws.xsd.ExchangeParameters;
import com.lbs.ws.xsd.ExchangeResult;
import com.lbs.ws.xsd.ExportParameters;
import com.lbs.ws.xsd.ExportResult;
import com.lbs.ws.xsd.ImportParameters;

public class DataExchangeServiceTest 
{

private static String m_RootURL = "http://localhost:8080/logo/services/";
    
    public static void main(java.lang.String args[])
    {
      try
		{
			ConfigurationContext cfg = ConfigurationContextFactory.createConfigurationContextFromFileSystem("D:\\osman",null);
			DataExchangeServiceStub stub = new DataExchangeServiceStub(cfg, m_RootURL + "DataExchangeService" );
			ServiceClient sc = stub._getServiceClient();
			sc.engageModule("addressing");
			sc.engageModule("rampart");			
			
			OutflowConfiguration outflowConfig = new OutflowConfiguration();
			outflowConfig.setActionItems("UsernameToken");
			outflowConfig.setUser("admin");
			outflowConfig.setPasswordCallbackClass("com.lbs.ws.test.SampleCallBackHandler");
			sc.getOptions().setProperty(WSSHandlerConstants.OUTFLOW_SECURITY, outflowConfig.getProperty());
				
			getByKey(stub);
//			describe(stub);
//			create(stub);
//			save(stub);
//			saveInv(stub);
//			removeByKey(stub);
		}
		catch (RemoteException e)
		{
			e.printStackTrace();
		}
    }

	private static void removeByKey(DataExchangeServiceStub stub)
	{
		RemoveByKey methodParams = new RemoveByKey();
		ExchangeParameters exchangeParams = new ExchangeParameters();
		exchangeParams.setBoName("com.lbs.unity.mm.bo.exchange.MMXOItem");
		exchangeParams.setDescriptive(true);
		exchangeParams.setFirm(1);
		exchangeParams.setPeriod(1);
		exchangeParams.setLanguage("TRTR");
		methodParams.setParameters(exchangeParams );
		methodParams.setPrimaryKey(26);
		try 
		{
			RemoveByKeyResponse response = stub.removeByKey(methodParams );
			ExchangeResult retVal = response.get_return();
			String errorMessage = retVal.getErrorMessage();
			boolean successful = retVal.getSuccessful();
			System.out.println(successful + " " + errorMessage);
		}
		catch (RemoteException e) 
		{
			e.printStackTrace();
		}
	}

	private static void saveInv(DataExchangeServiceStub stub)
	{
		try 
		{
			Save methodParam  = new Save();
			methodParam.setObjectXML(JLbsFileUtil.readTextFile("D://web//inv.xml"));
			
			ImportParameters param = new ImportParameters();
//			param.setBoName("com.lbs.unity.fi.bo.FIBOARPCard");
			param.setBoName("com.lbs.unity.lo.bo.LOBOInvoice");
			param.setFirm(1);
			param.setPeriod(1);
			param.setUseGivenPrimaryKeys(false);
			methodParam.setParameters(param );
			SaveResponse res = stub.save(methodParam);
			ExchangeResult returnVal = res.get_return();
			System.out.println(returnVal.getErrorMessage());
			System.out.println(returnVal.getSuccessful());
		} 
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	private static void save(DataExchangeServiceStub stub) 
	{
		try 
		{
			Save methodParam  = new Save();
			methodParam.setObjectXML(JLbsFileUtil.readTextFile("D://web//create.xml"));
			
			ImportParameters param = new ImportParameters();
			param.setBoName("com.lbs.unity.mm.bo.exchange.MMXOItem");
			param.setFirm(1);
			param.setPeriod(1);
			param.setUseGivenPrimaryKeys(false);
			methodParam.setParameters(param );
			SaveResponse res = stub.save(methodParam);
			ExchangeResult returnVal = res.get_return();
			System.out.println(returnVal.getErrorMessage());
			System.out.println(returnVal.getSuccessful() + " " + returnVal.getPrimaryKey());
		} 
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	private static void create(DataExchangeServiceStub stub)  
	{
		try 
		{
			Create methodparams = new Create();
			methodparams.setInitRequiredXML(JLbsFileUtil.readTextFile("D://web//init.xml"));
			ExchangeParameters param = new ExchangeParameters();
			param.setBoName("com.lbs.unity.mm.bo.exchange.MMXOItem");
			param.setDescriptive(false);
			param.setFirm(1);
			param.setLanguage("TRTR");
			param.setPeriod(1);
			methodparams.setParameters(param);
		
			CreateResponse response = stub.create(methodparams);
			ExportResult returnVal = response.get_return();
			System.out.println("Err: " + returnVal.getErrorMessage());
			System.out.println("Succesful: " + returnVal.getSuccessful());
			JLbsFileUtil.write2File("D://web//create.xml", returnVal.getResultXML().getBytes());
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	private static void describe(DataExchangeServiceStub stub) 
	{
		Describe methodParams = new Describe();
		DescribeParameters param = new DescribeParameters();
		param.setBoName("com.lbs.unity.mm.bo.exchange.MMXOItem");
		param.setDescriptive(false);
		param.setEmptyXML(true);
		param.setFirm(1);
		param.setInitRequiredXML(true);
		param.setLanguage("TRTR");
		param.setPeriod(1);
		param.setSampleXML(true);
		param.setSecKeyXML(true);
		methodParams.setParameters(param);
		
		try 
		{
			DescribeResponse response = stub.describe(methodParams);
			DescribeResult returnVal = response.get_return();
			JLbsFileUtil.write2File("D://web//empty.xml", returnVal.getEmptyXML().getBytes());
			JLbsFileUtil.write2File("D://web//init.xml", returnVal.getInitRequiredXML().getBytes());
			JLbsFileUtil.write2File("D://web//sample.xml", returnVal.getSampleXML().getBytes());
			JLbsFileUtil.write2File("D://web//seckey.xml", returnVal.getSecKeyXML().getBytes());
			
		} 
		catch (RemoteException e) 
		{
			e.printStackTrace();
		}
	}

	private static void getByKey(DataExchangeServiceStub stub) throws RemoteException 
	{
		GetByKey methodParams = new GetByKey();
		methodParams.setInitRequiredXML("");
		methodParams.setPrimaryKey(20);
		
		ExportParameters params = new ExportParameters();
		params.setBoName("com.lbs.unity.mm.bo.exchange.MMXOItem");
		params.setDescriptive(false);
		params.setExcludeBlobFields(true);
		params.setExcludeClobFields(true);
		params.setFirm(1);
		params.setLanguage("TRTR");
		params.setPeriod(1);

		methodParams.setParameters(params );
		GetByKeyResponse res = stub.getByKey(methodParams);
		ExportResult returnVal = res.get_return();
		System.out.println("Err: " + returnVal.getErrorMessage());
		System.out.println("Succesful: " + returnVal.getSuccessful());
		JLbsFileUtil.write2File("D://web//itemReadByKey.xml", returnVal.getResultXML().getBytes());
		
	}

}
