package com.lbs.ws.test;

import java.rmi.RemoteException;

import org.apache.axis2.client.ServiceClient;
import org.apache.axis2.context.ConfigurationContext;
import org.apache.axis2.context.ConfigurationContextFactory;
import org.apache.rampart.handler.WSSHandlerConstants;
import org.apache.rampart.handler.config.OutflowConfiguration;

import com.lbs.ws.reporting.ExecuteReport;
import com.lbs.ws.reporting.ExecuteReportResponse;
import com.lbs.ws.reporting.GetFilterList;
import com.lbs.ws.reporting.GetFilterListResponse;
import com.lbs.ws.reporting.ReportingWebServiceStub;
import com.lbs.ws.reporting.xsd.RWSBasicParams;
import com.lbs.ws.reporting.xsd.RWSFilterParams;
import com.lbs.ws.reporting.xsd.RWSParams;

public class ReportTest {
private static String m_RootURL = "http://localhost:8080/logo/services/";
    
    public static void main(java.lang.String args[])
    {
      try
		{
			ConfigurationContext cfg = ConfigurationContextFactory.createConfigurationContextFromFileSystem("D:\\osman",null);
			ReportingWebServiceStub stub = new ReportingWebServiceStub(cfg, m_RootURL + "ReportingWebService" );
			ServiceClient sc = stub._getServiceClient();
			sc.engageModule("addressing");
			sc.engageModule("rampart");			
			
			OutflowConfiguration outflowConfig = new OutflowConfiguration();
			outflowConfig.setActionItems("UsernameToken");
			outflowConfig.setUser("admin");
			outflowConfig.setPasswordCallbackClass("com.lbs.ws.test.SampleCallBackHandler");
			sc.getOptions().setProperty(WSSHandlerConstants.OUTFLOW_SECURITY, outflowConfig.getProperty());
			
			executReport(stub);
//			getFilterList(stub);
		}
		catch (RemoteException e)
		{
			e.printStackTrace();
		}
    }

	private static void getFilterList(ReportingWebServiceStub stub) 
	{
		GetFilterList methodParams = new GetFilterList();
		RWSBasicParams basicParams = new RWSBasicParams();
		basicParams.setFirm(1);
		basicParams.setLanguage("TRTR");
		basicParams.setPeriod(1);
		methodParams.setBasicParams(basicParams);
		
		RWSFilterParams filterParams = new RWSFilterParams();
		filterParams.setRepName("MMRPItemsList");
		methodParams.setFilterParams(filterParams );
		
		try 
		{
			GetFilterListResponse res = stub.getFilterList(methodParams);
			String get_return = res.get_return();
			System.out.println(get_return);
		}
		catch (RemoteException e) 
		{
			e.printStackTrace();
		}
	}

	private static void executReport(ReportingWebServiceStub stub) 
	{
		ExecuteReport methodParams = new ExecuteReport();
		RWSBasicParams param = new RWSBasicParams();
		param.setFirm(1);
		param.setLanguage("TRTR");
		param.setPeriod(1);
		methodParams.setBasicParams(param);
		RWSParams params = new RWSParams();
		params.setReportName("MMRPItemsList");
		params.setOutputType(4);
		
		String filter = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> " +
				"<navi-filters> " + 
				"<filter type=\"9\" id=\"1\" value=\"1\" />" +
				"</navi-filters>";
		
		params.setFiltersValues(filter); 
		methodParams.setParams(params);
		try 
		{
			ExecuteReportResponse executeReport = stub.executeReport(methodParams);
			String get_return = executeReport.get_return();
			System.out.println(get_return);
		} 
		catch (RemoteException e) 
		{
			e.printStackTrace();
		}
	}
}
