package com.lbs.ws.test;

import java.rmi.RemoteException;

import org.apache.axis2.client.ServiceClient;
import org.apache.axis2.context.ConfigurationContext;
import org.apache.axis2.context.ConfigurationContextFactory;
import org.apache.rampart.handler.WSSHandlerConstants;
import org.apache.rampart.handler.config.OutflowConfiguration;

import com.lbs.ws.query.DataQueryServiceStub;
import com.lbs.ws.query.First;
import com.lbs.ws.query.FirstResponse;
import com.lbs.ws.query.GetBrowserQueryInfo;
import com.lbs.ws.query.GetBrowserQueryInfoResponse;
import com.lbs.ws.query.Search;
import com.lbs.ws.query.SearchResponse;
import com.lbs.ws.query.xsd.DataQueryBrowserFilter;
import com.lbs.ws.query.xsd.DataQueryBrowserInfo;
import com.lbs.ws.query.xsd.DataQueryParameterValue;
import com.lbs.ws.query.xsd.DataQueryParams;
import com.lbs.ws.query.xsd.DataQueryResult;

public class WebServiceTest {
private static String m_RootURL = "http://localhost:8080/UnityWebTier/services/";
    
    public static void main(java.lang.String args[])
    {
      try
		{
			ConfigurationContext cfg = ConfigurationContextFactory.createConfigurationContextFromFileSystem("D:\\mdls",null);
			DataQueryServiceStub stub = new DataQueryServiceStub(cfg, m_RootURL+"DataQueryService" );
			DataQueryServiceStub service = stub;
			ServiceClient sc = stub._getServiceClient();
			sc.engageModule("addressing");
			sc.engageModule("rampart");			

			OutflowConfiguration outflowConfig = new OutflowConfiguration();
			outflowConfig.setActionItems("UsernameToken");
			outflowConfig.setUser("admin");
			outflowConfig.setPasswordCallbackClass("com.lbs.ws.test.SampleCallBackHandler");
			sc.getOptions().setProperty(WSSHandlerConstants.OUTFLOW_SECURITY, outflowConfig.getProperty());
				
//			getBrowserQueryInfo(stub);
//			first(stub);
//			search(stub);
		}
		catch (RemoteException e)
		{
			e.printStackTrace();
		}
    }

	private static void search(DataQueryServiceStub stub) 
	{
		Search methodParams = new Search();
		methodParams.setMaxCount(22);
		methodParams.setQueryName("MMQOItemBrowser");
		methodParams.setRefPrimaryKey(4);
		methodParams.setReverse(false);
		methodParams.setSearchComparison(0);
		
		DataQueryParams param = new DataQueryParams();
		param.setFirm(1);
		param.setPeriod(1);
		methodParams.setParams(param);
		
		try 
		{
			SearchResponse res = stub.search(methodParams);
			DataQueryResult returnVal = res.get_return();
			System.out.println("Err: " + returnVal.getErrorMessage());
		}
		catch (RemoteException e) 
		{
			e.printStackTrace();
		}
		
	}

	private static void first(DataQueryServiceStub stub) 
	{
		First methodParams = new First();
		methodParams.setMaxCount(9999);
		methodParams.setQueryName("MMQOItemBrowser");
		methodParams.setReverse(true);
		DataQueryParams param = new DataQueryParams();
		param.setFirm(1);
		param.setPeriod(1);
		param.setEnabledTerms("T11");
		param.setEnabledTerms("T2");

		DataQueryParameterValue p1 = new DataQueryParameterValue();
		p1.setParameterName("P_CODE");
		p1.setParameterType("string");
		p1.setParameterValue("aa%");
		
		
		DataQueryParameterValue[] valueArr = new DataQueryParameterValue[]{p1};
		param.setParameterValues(valueArr);
		methodParams.setParams(param);
		
		try 
		{
			FirstResponse res = stub.first(methodParams);
			DataQueryResult returnVal = res.get_return();
			System.out.println("Err: " + returnVal.getErrorMessage());
			System.out.println("Succesful: " + returnVal.getSuccessful());
		}
		catch (RemoteException e)
		{
			e.printStackTrace();
		}
	}

	private static void getBrowserQueryInfo(DataQueryServiceStub stub) 
	{
		GetBrowserQueryInfo methodParams = new GetBrowserQueryInfo();
		methodParams.setBrowserName("MMXFItemBrowser.jfm");
		methodParams.setFirm(1);
		methodParams.setLanguage("TRTR");
		methodParams.setPeriod(1);
		
		try 
		{
			GetBrowserQueryInfoResponse browserQueryInfo = stub.getBrowserQueryInfo(methodParams);
			DataQueryBrowserInfo returnVal = browserQueryInfo.get_return();
			System.out.println("Err msg: " + returnVal.getErrorMessage());
			System.out.println("Succesful : " + returnVal.getSuccessful());
			System.out.println("Sorgu ad: " + returnVal.getQueryName());
			DataQueryBrowserFilter[] filters = returnVal.getFilters();
			for(int i = 0; i<filters.length; i++)
			{
				DataQueryBrowserFilter dataQueryBrowserFilter = filters[i];
				int id = dataQueryBrowserFilter.getId();
				String caption = dataQueryBrowserFilter.getCaption();
				boolean range = dataQueryBrowserFilter.getRange();
				String list = dataQueryBrowserFilter.getList();
				String type = dataQueryBrowserFilter.getType();
				
				System.out.println("id: " + id + " Caption: " + caption +  " range: " + range + " list: " + list + " type: " + type);
				
			}
		} 
		catch (RemoteException e) 
		{
			e.printStackTrace();
		}
	}

}
